import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//********************************************************************

class nubj_group extends nubj implements Cloneable

//********************************************************************
{
    double xxc; 
    double yyc;                     
    Color c;
    nubj_list glist;

    nubj_group(nubj_list p, nubj_list q)
    {
	super(p);
	glist = new nubj_list();
	unir=false;
	gru=true;
	nubj i,ii;
	select = 0;	

	for(i = q.ghead;i!=null;i=ii)
	    {
		ii = i.next;

		if(i.select!=0)
		    {
			i.unlink();
			i.link(glist);
			i.select = 0;
		    }
	    }
	select = 1;
	xmin = ymin = 2000;
	xmax = ymax = -2000;
	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
	    }
	xg[0]=xmin; xg[1]=xmax; yg[0]=ymin; yg[1]=ymax;
	xd[0]=(double)xg[0]; xd[1]=(double)xg[1]; yd[0]=(double)yg[0];
	yd[1]=(double)yg[1];
	xc = (xmin+xmax)/2;
	yc = (ymin+ymax)/2;
	zc = (zmin+zmax)/2;
    }

    public void ungroup()
    {
      nubj i;
	for(i=glist.ghead;i!=null;i=i.next)
	  {
	    if(this.unir==true) return;
	    i.select = 1;
	  }
	if(parent.ghead==null)
	  parent.ghead = glist.ghead;
	if(parent.gtail!=null)
	  parent.gtail.next = glist.ghead;
	if(glist.ghead!=null)
	  glist.ghead.prev = parent.gtail;
	parent.gtail = glist.gtail;
	
	for(i=parent.ghead;i!=null;i=i.next)
	    i.parent = parent;
	select = 0;
	unlink();
	parent = null;
	next = null;
	prev = null;
    }

    public void setcolor(Color icc)
    {
	for(nubj i = glist.ghead;i!=null;i=i.next)
	    i.setcolor(icc);
    }

    public void setcolorline(Color icl)
    {
	for(nubj i = glist.ghead;i!=null;i=i.next)
	    i.setcolorline(icl);
    }

    public void thick()
    {
	for(nubj i = glist.ghead;i!=null;i=i.next)
	    i.thick();
    }

    public void thin()
    {
	for(nubj i = glist.ghead;i!=null;i=i.next)
	    i.thin();
    }

    public void setFill(int ifill)
    {
	for(nubj i = glist.ghead;i!=null;i=i.next)
	    i.setFill(ifill);
    }

    public void paint(Graphics g) 
    {
	for(nubj i = glist.ghead;i!=null;i=i.next)
	    {
		i.paint(g);
	    }
	if(select!=0)
	    {
		g.setColor(Color.red);
		g.drawRect(xmin,ymin,(xmax-xmin),(ymax-ymin));
	    }
    }
    public void metapost(BufferedWriter out) 
    {     
	for(nubj i = glist.ghead;i!=null;i=i.next)
	    i.metapost(out);
    }

    public void changeCoor(int change)
    {
	nubj i;
	xmin = ymin = zmin = 2000;
	xmax = ymax = zmax = -2000;
	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
		if(i.zmin<zmin) zmin = i.zmin;
		if(i.zmax>zmax) zmax = i.zmax;
	    }
	xc = (xmin+xmax)/2;
	yc = (ymin+ymax)/2;
	zc = (zmin+zmax)/2;
	for(i = glist.ghead;i!=null;i=i.next){
	    i.change=change;
	    i.changeCoor(change);}
    }

    public void transform(double xc, double yc, double zc)
    {
	nubj i;
	xmin = ymin = zmin = 1000;
	xmax = ymax = zmax = -1000;
	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
		if(i.zmin<zmin) zmin = i.zmin;
		if(i.zmax>zmax) zmax = i.zmax;
	    }
	for(i = glist.ghead;i!=null;i=i.next){
	    i.value=value;
	    i.setEscal(nubj.es);
	    i.transform(xc, yc, zc);}
    }
    public void moveobj(int x,int y)
    {
	nubj i;

	for(i = glist.ghead;i!=null;i=i.next)
	    i.moveobj(x,y);
	xmin = ymin = 1000;
	xmax = ymax = -1000;
	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
	    }
    }

    public boolean selectpoint(int x,int y)
    {
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
	if(x>=xmin && x<=xmax && y>=ymin && y<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
}
